#!/usr/bin/env python3
"""
manipulations complexes de tableaux : listes d'intervalles.
"""


class Ressources:
    """
    On stocke une liste de ressources, compressee par plages contigues.
    """
    def __init__(self, nombre_ressources, intervalles=None):
        # requiert : si intervalles is not None, alors :
        #            - les intervalles sont non vides
        #            - les intervalles sont non contigus
        #            - les intervalles sont tries par indices croissants
        #            - intervalles[-1][1] <= nombre_ressources
        self.nombre_ressources = nombre_ressources
        if intervalles is not None:
            self.intervalles = intervalles
        else:
            self.intervalles = [[0, nombre_ressources]]

    def disponible(self, indice):
        """
        renvoie si l'indice donne est disponible dans la ressource.
        """
        # TODO
        pass

    def reserve(self, ressources_demandees):
        """
        enleve le nombre de ressources demandees (premieres disponibles).
        renvoie les ressources correspondant aux plages reservees.
        """
        # TODO
        pass

    def retourne(self, ressources_rendues):
        """
        remet les plages de ressources donnees dans le systeme.
        """
        # TODO
        pass

    def __str__(self):
        """
        renvoie une chaine 'visuelle' des ressources contenues dans self.
        par exemple, '|x..xxxxx..|' indique qu'il y a 10 ressources,
        les ressources 0, 3-7 sont disponibles.
        """
        # TODO
        pass

def test():
    """
    on teste en gruyerisant une ressource.
    """
    ressources = Ressources(10)
    print("Disponibles :", ressources)
    reservees = [ressources.reserve(c) for c in (2, 2, 3, 2, 1)]
    print("Disponibles :", ressources)
    ressources.retourne(reservees[1])
    print("Disponibles :", ressources)
    ressources.retourne(reservees[3])
    print("Disponibles :", ressources)
    print("Reservees   :", ressources.reserve(3))
    print("Disponibles :", ressources)
    print("Les intervalles :", ressources.intervalles)

if __name__ == "__main__":
    test()
